#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>
#include "screen.h"
#include "poly.h"
#include "3D.h"

struct Object *obj ;
struct Camera viewp ;
double o ;
GLdouble vertex[3] ;
GLdouble color[3]={1.0,0.5,1.0} ;

GLfloat light0pos[] = { 5.0, 3.0, 100.0, 1.0 };
GLfloat red[]       = { 0.8, 0.2,   0.2, 1.0 };

void read_obj( struct Object *obj ) ;

void idle(void)
{
  glutPostRedisplay();
}

void resize(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30.0, (double)w / (double)h, 1.0, 200.0);
  glTranslated(0.0, 0.0, -5.0);
  gluLookAt(0.0, 0.0, 100.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  glMatrixMode(GL_MODELVIEW);
}

void display(void)
{
  int i,j;
  struct Poly *polyp ;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glLoadIdentity();
  gluLookAt(3.0, 4.0, 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);

  o=o+0.2 ;
  if( o>360.0 ) o=0 ;

  //glColor3d(0.0, 0.0, 0.0);

  glLightfv(GL_LIGHT0, GL_POSITION, light0pos);

  glRotated( o , 2.0, 1.3, 0.6);

  glBegin(GL_QUADS);
    
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, red);
  polyp=obj->arry ;
  for ( j=0 ; j < obj->num-4 ; j++ ){
    glColor3dv(color);
    SetPolyVector( polyp ) ;
    vertex[0]=polyp->pnx ;
    vertex[1]=polyp->pny ;
    vertex[2]=polyp->pnz ;
    glNormal3dv(vertex);
    for ( i=0 ; i<3 ; i++ ){
      vertex[0]=polyp->p[i]->x/4 ;
      vertex[1]=polyp->p[i]->y/4 ;
      vertex[2]=polyp->p[i]->z/4 ;
      glVertex3dv(vertex);
    }
    vertex[0]=polyp->p[0]->x/4 ;
    vertex[1]=polyp->p[0]->y/4 ;
    vertex[2]=polyp->p[0]->z/4 ;
    glVertex3dv(vertex);
    polyp=polyp->next ;
  }
  glEnd();
  glFlush();
}  

void init(void)
{
  glClearColor(0.0,0.0,1.0,0.5) ;
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  glCullFace(GL_FRONT);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  o=0 ;
}

int main(int argc, char *argv[])
{
int i ;

 obj=create_polylist() ;
 if( obj==NULL ){
    printf("Can not create Object\n") ;
    exit(-1) ;
 }
 read_obj( obj ) ;

 glutInit(&argc, argv);
 glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH);
 glutCreateWindow(argv[0]);
 glutDisplayFunc(display);
 glutReshapeFunc(resize);
 glutIdleFunc(idle); 
 init();
 glutMainLoop();
 
 exit(0) ;
}
